/* This file is a template of the code which can use the API. 
   You can copy and extend the file as you like.
*/

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

// First, 'usual' include files are specified, e.g.
#ifdef _WINDOWS
#include "stdafx.h"
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* The symbol 'uniontest' below is used by syntapi.h and propapi.h to specify 
   the action when a dynamic type checking error is detected. It is good practice 
   to detect such errors, at least in a DEBUG version.
*/

#ifdef _DEBUG
#define uniontest(t) fatalerror("Ups ... illegal union field selection")
#else
#define uniontest(t) 
#endif

#include <syntapi.h>
#include <propapi.h>

using namespace CSDL_IR;

/* The exported 'Main' DLL function contains the user defined code which
   manipulates the 'tree'. The root class 'Capi' is defined in syntapi.h. 
*/
extern "C" __declspec(dllexport) void Main(class Capi *tree);

/* The exported 'GetName' DLL function contains the text to appear in the tools menu of Cinderella SDL.
The procedure is not used when the DLL is invoked through the command line analyzer (CSDLPR)
*/

extern "C" __declspec(dllexport) void GetName(char *str);
extern "C" __declspec(dllexport) BOOL Enable(class Capi *tree);

/* The fatalerror procedure below is called by the API, when an unforseen situation occurs.
   This procedure must always be defined. After issuing a message, 
   the procedure should throw an exception to be catch somewhere.
*/

void fatalerror(char *str1,char *str2)
{ 
#ifdef _WINDOWS
  CString str;
  str.Format(str1,str2);
  if (AfxMessageBox(str + "\nAbort?",MB_YESNO) == IDYES)
    throw 0;
#else
  fprintf(stdout,str1,str2);
  throw 0;
#endif
}

void Main(Capi *tree)
{ tree->initialise();
  /* Place your code here, e.g. */
#ifdef _WINDOWS
  AfxMessageBox("This is a test");
#else
  fprintf(stdout,"This is a test");
#endif
}

void GetName(char *str)
{ strcpy(str,"hello2");
}
/*
BOOL Enable(Capi *tree)
{ return TRUE;
}
*/